diff --git a/guix/transformations.scm b/guix/transformations.scm
index 47eb4b0515..122b0e74aa 100644
--- a/guix/transformations.scm
+++ b/guix/transformations.scm
@@ -33,7 +33,9 @@ (define-module (guix transformations)
   #:autoload   (guix upstream) (package-latest-release
                                 upstream-source-version
                                 upstream-source-signature-urls)
-  #:autoload   (guix cpu) (current-cpu cpu->gcc-architecture)
+  #:autoload   (guix cpu) (current-cpu
+                           cpu->gcc-architecture
+                           gcc-architecture->generic-architecture)
   #:use-module (guix utils)
   #:use-module (guix memoization)
   #:use-module (guix gexp)
@@ -568,16 +570,19 @@ (define (build-system-with-tuning-compiler bs micro-architecture)
 
 (define (tuned-package p micro-architecture)
   "Return package P tuned for MICRO-ARCHITECTURE."
+  (let ((generic-micro-arch (gcc-architecture->generic-architecture
+                              micro-architecture)))
   (package
     (inherit p)
     (build-system
-      ;; The go compiler doesn't need to be wrapped.
-      ;; XXX: This is where we check for supported micro-architectures.
-      (if (eq? (build-system-name (package-build-system p))
-               'go)
+      ;; The go compiler doesn't need to be wrapped but we want the error
+      ;; checking to make sure we're targeting a recognized optimization target.
+      (build-system-with-tuning-compiler
         (package-build-system p)
-        (build-system-with-tuning-compiler (package-build-system p)
-                                           micro-architecture)))
+        (if (eq? (build-system-name (package-build-system p))
+                 'go)
+          generic-micro-arch
+          micro-architecture)))
     (arguments
      ;; The machine building this package may or may not be able to run code
      ;; for MICRO-ARCHITECTURE.  Because of that, skip tests; they are run for
@@ -591,21 +596,20 @@ (define (tuned-package p micro-architecture)
           #~(modify-phases #$phases
               (add-after 'setup-go-environment 'set-microarchitecture
                 (lambda _
-                  (let ((microarch #$micro-architecture))
-                    (cond
-                      ((string-prefix? "arm" microarch)
-                       (setenv "GOARM" (string-take-right microarch 1))
-                       (format #t "Setting GOARM to ~s."
-                               (getenv "GOARM")))
-                      ((string-prefix? "powerpc" microarch)
-                       (setenv "GOPPC64" microarch)
-                       (format #t "Setting GOPPC64 to ~s."
-                               (getenv "GOPPC64")))
-                      ((string-prefix? "x86_64" microarch)
-                       (setenv "GOAMD" (string-take-right microarch 2))
-                       (format #t "Setting GOAMD to ~s.\n"
-                               (getenv "GOAMD")))
-                      (else #t))))))
+                  (cond
+                    ((string-prefix? "arm" #$generic-micro-arch)
+                     (setenv "GOARM" (string-take-right #$generic-micro-arch 1))
+                     (format #t "Setting GOARM to ~s."
+                             (getenv "GOARM")))
+                    ((string-prefix? "powerpc" #$generic-micro-arch)
+                     (setenv "GOPPC64" #$generic-micro-arch)
+                     (format #t "Setting GOPPC64 to ~s."
+                             (getenv "GOPPC64")))
+                    ((string-prefix? "x86_64" #$generic-micro-arch)
+                     (setenv "GOAMD" (string-take-right #$generic-micro-arch 2))
+                     (format #t "Setting GOAMD to ~s.\n"
+                             (getenv "GOAMD")))
+                    (else #t)))))
           phases))))
 
     (properties
@@ -613,7 +617,7 @@ (define (tuned-package p micro-architecture)
 
        ;; Remove the 'tunable?' property so that 'package-tuning' does not
        ;; call 'tuned-package' again on this one.
-       ,@(alist-delete 'tunable? (package-properties p))))))
+       ,@(alist-delete 'tunable? (package-properties p)))))))
 
 (define (tunable-package? package)
   "Return true if package PACKAGE is \"tunable\"--i.e., if tuning it for the